p_PeopleHandler/Demo

	//
	//	Define the display procs to go along with your interface.
	//	The interface for this demo can be found in _demo.dmf.
	//	I chose a grid control just to have something different from the usual output.
	//	The library doesn't care.
	//

	//	I don't actually use this proc in the demo,
	//	but I wanted to point out that it doesn't do much by default.
	p_DisplayPeopleToViewer(Viewer)
		.			= ..(Viewer)
		if ( !(.) )	return .

		var/rows	= src.p_GetNumberOfPlayers()
		rows		+= src.p_GetNumberOfSpectators()
		rows		+= src.p_GetNumberOfWaiters()

		winset(Viewer,"people","cells=2x[rows]")

		var/person
		for(person in src.p_GetListOfSpectators())
			Viewer	<< output(person,"people:1,[rows]")
			Viewer	<< output("Is Spectating","people:2,[rows]")
			rows--
		for(person in src.p_GetListOfWaiters())
			Viewer	<< output(person,"people:1,[rows]")
			Viewer	<< output("Is Waiting","people:2,[rows]")
			rows--
		for(person in src.p_GetListOfPlayers())
			Viewer	<< output(person,"people:1,[rows]")
			Viewer	<< output("Is Playing","people:2,[rows]")
			rows--
	//	It is probably more efficient to use the included output procs
	//	then to call the above proc repeatedly when dealing with a large number of people.
	p_DisplayPeopleToAll(AutomatedCall=FALSE)
		var/rows	= src.p_GetNumberOfPlayers()
		rows		+= src.p_GetNumberOfSpectators()
		rows		+= src.p_GetNumberOfWaiters()

		src.p_WinsetAll("people","cells=2x[rows]")

		var/person
		for(person in src.p_GetListOfSpectators())
			src.p_OutputAll(person,"people:1,[rows]")
			src.p_OutputAll("Is Spectating","people:2,[rows]")
			rows--
		for(person in src.p_GetListOfWaiters())
			src.p_OutputAll(person,"people:1,[rows]")
			src.p_OutputAll("Is Waiting","people:2,[rows]")
			rows--
		for(person in src.p_GetListOfPlayers())
			src.p_OutputAll(person,"people:1,[rows]")
			src.p_OutputAll("Is Playing","people:2,[rows]")
			rows--



//	Create a p_PeopleHandler somewhere.
var/p_PeopleHandler/Demo/gPeople	= new



mob

	Login()
		..()

		//	The interface procs are not defined in this demo.
		//	However, p_Reconnected() would call the proper proc for you.
		gPeople.p_Reconnected(src)

		//	People who just joined are usually considered spectators.
		gPeople.p_AddSpectator(src)

	Logout()
		..()
		//	We're not defining p_Disconnected to do anything.
		//	However, it might be good to get in the habit of calling it for extensions.
		gPeople.p_Disconnected(src)


	verb
		//	Hop around the different categories and notice how the display is automatically updated.
		play()
			gPeople.p_AddPlayer(src)
		wait()
			gPeople.p_AddWaiter(src)
		spectate()
			gPeople.p_AddSpectator(src)

		//	The mass output procs are good for communication.
		//	Plus, here's something to do if you host the demo to test with multiple people.
		say(blah as text)
			gPeople.p_OutputAll("<strong>[src]</strong>: [blah]","chat")
