p_PeopleHandler

	//============================================================================================
	New()
		..()
		src.p_players		= list()
		src.p_waiters		= list()
		src.p_spectators	= list()

	//============================================================================================
	proc
		//----------------------------------------------------------------------------------------
		//	This does nothing by default.  You may want to call this when logging out anyway.
		//	Library extensions may use it.
		p_Disconnected(Person)

		//----------------------------------------------------------------------------------------
		//	Display the people to Viewer.
		//	By default all this does is return TRUE if Viewer is capable of viewing the display.
		p_DisplayPeopleToViewer(Viewer)
			if ( ismob(Viewer) )
				var/mob/M	= Viewer
				return !isnull(M.client)
			return istype(Viewer,/client)

		//----------------------------------------------------------------------------------------
		//	Display the people to everyone.
		//	By default, this does nothing.
		//	If called internally, AutomatedCall is TRUE.
		p_DisplayPeopleToAll(AutomatedCall=FALSE)

		//----------------------------------------------------------------------------------------
		//	Returns all people in the handler.
		p_GetListOfAll()
			.	= list()
			.	+= src.p_players
			.	+= src.p_waiters
			.	+= src.p_spectators

		//----------------------------------------------------------------------------------------
		//	Returns whether or not Candidate is listed as a player, waiter or spectator.
		p_IsListed(Candidate)
			return ( (Candidate in src.p_players) || (Candidate in src.p_waiters) || (Candidate in src.p_spectators) )

		//----------------------------------------------------------------------------------------
		//	Send Message to all players, waiters, and spectators through Control.
		p_OutputAll(Message,Control)
			src.p_OutputPlayers(Message,Control)
			src.p_OutputWaiters(Message,Control)
			src.p_OutputSpectators(Message,Control)

		//----------------------------------------------------------------------------------------
		//	Adds the proper interface back to Person.  Call this when logging in.
		p_Reconnected(Person)
			if ( src.p_IsSpectating(Person) )	src.p_AddInterfaceSpectator(Person)
			else if ( src.p_IsPlaying(Person) )	src.p_AddInterfacePlayer(Person)
			else if (src.p_IsWaiting(Person) )	src.p_AddInterfaceWaiter(Person)

		//----------------------------------------------------------------------------------------
		//	Set the skin Control of all players, waiters, and spectators to use Params.
		p_WinsetAll(Control,Params)
			src.p_WinsetPlayers(Control,Params)
			src.p_WinsetWaiters(Control,Params)
			src.p_WinsetSpectators(Control,Params)
